/*
*****************************************************************************************************
-- DATABASELINK
*****************************************************************************************************
/*

-- DATABASELINKS ARE OBJECTS THAT ALLOW THE DIRECT COMMUNICATION TO A REMOTE ORACLE SERVER
-- A DATABASELINK CAN BE CREATED ON A DIFFERENT DBMS SUCH AS SQL SERVER (THROUGH ODBC)

-- FIRST, YOU CAN HAVE TO MAKE SURE THAT THERE IS CONNECTIVITY BETWEEN THE SERVER
-- CHECK FOR NETWORK SETTINGS, FIREWALL, VPN, ETC

-- NEXT, MAKE SURE YOU HAVE THE CORRECT ENTRY IN THE TNSLISTNENER.ORA FILE
-- SEE THE EXAMPLE TNSLISTENER.ORA. WE ARE GOING TO USE THE XE_REMOTE NAME

-- CHECK THE CONNECTION TO THE REMOTE SERVER USING SQLPLUS:
>sqlplus hr@XE_REMOTE


-- NOW ON THE LOCAL SERVER CREATE THE DATABASELIST USING THE CORRECT REMOTE SERVER NAME
-- MAKE SURE YOU USE A CORRECT USER/PASSWORD

CREATE DATABASE LINK XE_10G
CONNECT TO hr IDENTIFIED BY abc123
USING 'XE_REMOTE'; 

-- FINALLY, ACCESS THE OBJECTS OF THE REMOTE SERVER USING THE @ OPERATOR:

SELECT * FROM HR.EMPLOYEES
UPDATE HR.EMPLOYEES
SET SALARY = 100
WHERE EMPLOYEE_ID = 207

SELECT * FROM EMPLOYEES@XE_10G

-- CHECK INFORMATION ABOUT THE DATABASELINK USING THE USER_DB_LINKS VIEW:

SELECT * FROM USER_DB_LINKS;

-- YOU CAN REMOVE THE DATABASELINK, BUT MAKE SURE THAT NOBODY IS USINT IT

ALTER SESSION CLOSE DATABASE LINK XE_10G;

DROP DATABASE LINK XE_10G;

*/
